// ======================== Atmega128 ؽƮ LCD α׷ =====================
//  CPU : ATmega128-16M - ؽƮ LCD(2*16)
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : AvrStudio 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#define	__STDIO_FDEVOPEN_COMPAT_12

// ⺻ 
// === AVR includes ===
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
//#include <float.h>
//#include <math.h>

#include "avr/io.h"
#include "avr/interrupt.h"
#include "avr/delay.h"
#include "avr/pgmspace.h"

//  
#include "cpusetup.inc"							// cpu  ͷƮ  ƾ
#include "textlcd.inc"							// Text LCD

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();							// cpu ʱȭ
	LCD_Init();							// LCD ʱȭ
	main_menu_disp();						//  ޴ ǥ
	Putsxyt(1,1,"  MEGA128_Clcd  ");
	Putsxyt(1,2,"www.cpuplaza.com");
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '1') Clrscr();		// ȭ 
			else if(com1_rx_data == '2') Putch('1');	// 1 ǥ
			else if(com1_rx_data == '3') Putchxyt(1,1,'3');	// ؽƮ ǥ 1 ǥ
			else if(com1_rx_data == '4') Puts("123");	// ڿ ǥ
			else if(com1_rx_data == '5'){			// ؽƮ ǥ ڿ ǥ
				Putsxyt(1,1,"LCD TEST LINE1");
				Putsxyt(1,2,"LCD TEST LINE2");
			}
			else if(com1_rx_data == '6') Cursor_Set(ON);	// Ŀ ON
			else if(com1_rx_data == '7') Cursor_Set(OFF);	// Ŀ OFF
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("%s","========== LCD Test Main =========\n");
	printf("%s","- 1 : Clrscr                     -\n");
	printf("%s","- 2 : Putch                      -\n");
	printf("%s","- 3 : Putchxyt                   -\n");
	printf("%s","- 4 : Puts                       -\n");
	printf("%s","- 5 : Putsxyt                    -\n");
	printf("%s","- 6 : Cursor ON                  -\n");
	printf("%s","- 7 : Cursor OFF                 -\n");
	printf("%s","----------------------------------\n");
}

